************************************************
GMUSIC

Generic MUSIC Simulation Package

Alfred Tang
Kansas State University
January 2007
atang@phys.ksu.edu

************************************************

Content:
********
1.  makefiles (makefile & makemugen)
2.  muon.f -- main program for muons at the far lab
3.  mugen.f -- main program for generating final muon momentum to be used
    FLUKA and GEANT
4.  muon_flux_dbs.f -- mofidied Gaisser distribution generator
5.  music-sr.f -- MUSIC subroutine
6.  music-cross-sections-sr.dat -- datafile
7.  music-double-diff-rock.dat -- datafile
8.  music-eloss-sr.dat -- datefile
9.  ranum.f -- random number header
10. ebin.c -- binning program
11. nr.h -- modified Numerical Recipes header files
12. nrutil.h -- modified Numerical Recipes header files
13. nrutil.c -- modified Numerical Recipes header files
14. fixdat.c -- utility program to post-process raw mountain profile
    generated by 3DField

Short Description
*****************
There are 2 main FORTRAN programs in this package (muon.f and mugen.f)
that propagate muons from the surface of an arbitrary mountain to an
underground lab using MUSIC.  The first program (muon.f) generates E,
cos(theta) and phi uniformly and is designed to calculate average observables
and various distributions very accurately and efficiently.  The second program
(mugen.f) generates E, cos(theta) and phi according to the modified
Gaisser sealevel distribution.  It is not as accurate and efficient as
muon.f in terms of calculating average observables and distributions but
is ideal for generating final muon momentum as input for FLUKA and GEANT.


Installation and Run
********************
1.  Unpack the tar ball and make sure that all the files are placed in
    the same directory.
2.  Make sure that you have CERNLIB (version 2003 or later) installed on
    your system.
3.  Create an environment value CERNLIB for cernlib.  It is recommended that
    the environment value be placed permanently in the setup files such as
    .bashrc, .bash_profile, .tcshrc, .tcsh+profile or so on.  Suppose that
    cernlib is put in a directory called /cern/lib, then add the line
    export CERNLIB=/cern/lib
    in bash, or
    setenv CERNLIB /cern/lib
    in tcsh in the corresponding setup file so that makefile can find the
    cernlib directory.  Similarly, create another environment variable
    CERNROOT.  In this example, add the line
    export CERNROOT=/cern
    in bash, or
    setenv CERNROOT /cern
    in tcsh in the appropriate setup file.
4.  The files border.dat and labxyz.dat are needed by muon.f and mugen.f
    and are created by fixdat.c.  Make sure that a raw data file called
    rawxyz.dat is generated by 3DField.  A quick start guide of how to use
    3DField is posted at http://www.phys.ksu.edu/personal/atang/3dfield.htm.
5.  Right now the number of simulation events in muon.f is set as
    10000.  It is a good number to use when you are testing the program
    because the run time is typically 2-3 minutes on one processor.  For
    production run, set nthrows=1000000 (or higher) in muon.f.  It takes
    approximately 2 hours to run 10^6 events on one processor.  A similar
    arrangement is made for mugen.f.
6.  muon.f uses uniform generation to simulate raw data to be post-processed
    by another program called ebin.c to calculate various observables and
    distributions.  Type "make" at the command prompt to create an executable
    called "musim".  Then type
    $./musim
    at the prompt to run the program.
7.  mugen.f uses generation according to the distribution and creates
    a list of final muon momentum as input for FLUKA and GEANT.  Select
    an option by modifying a line in the beginning of the program:
      parameter (option=1)
    Choose option=1 if final muons are sampled at the center of the
    detector and option=2 if final muons are sampled on a large hemispherical
    vacuum.  Option 2 is set as default.  Choose the number of events by
    modifying the line
      nthrows=1000000
    accordingly.  The survival probability of muons is about 4%.  If 40000
    muons are desired, 10^6 initial muons are needed and so on.
    To make the program, type:
    $make -f makemugen
    To run the program, type:
    $./mugen
8.  The random seed can be modified by changing the integer on the line:
      iranlux=1
9.  The unit of energy/momentum in MUSIC is always GeV.
10. To optmize efficiency, the parameter lemin in muon_flux_dbs.f and
    mugen.f should be set to the log(Emin) where Emin is the minimum
    energy needed to propagate a muon across the minimum thickness of rock.


Outputs of muon.f
********************
1.  A summary of the results will be printed to the screen and to the
    output file edbs.dat.
2.  The file edist.dat contains a record of all the surviving muons in
    columns corresponding to energy, "flux", theta and phi.  The meaning
    of "flux" can be understood by looking into muon_flux_dbs.f whose role
    to measure the weight of each surviving muon for post-processing
    purpose.
3   The file edist.dat contains the output data in columns of muon energy,
    weight, theta and phi.  This file need to be post-processed by the
    program ebin to generate various kinds of distributions.

Output of mugen.f
********************
1.  A summary of the results will be printed to the screen.
2.  The file pxyz.dat contains rows of the x,y,z-components of the final muon
    momentum in the order of (px,py,pz).


******************************

Instruction for running ebin.c

ebin.c is a program that calculates the
energy and double differential
angular distribution from edist.dat
generated by versions of MUSIC
programs written by the author.

******************************

Installation
************

1.  Go a direcoty where you want ebin.c to run.  The program does not have
    any dependence.  It does not matter where you want to put the program.
2.  Untar and unzip ebin.tar.gz by issuing
      $ tar zxvf ebin.tar.gz
3.  To compile the program, type
      $ gcc -o ebin ebin.c -lm
4.  The executable is ebin.

Run
***

1.  Make sure that you have edist.dat in the same directory.
2.  In general it is a good idea to save edbs.dat and edist.dat to other names
    because it is going to be written over everytime you re-run the MUSIC
    program.
3.  Save the output files for example by typing:
       $ cp edbs.dat edbs_dc.dat
       $ cp edist.dat edist_dc.dat
4.  To run ebin, do the following

       $ ./ebin
       Enter the root name of the input file: _dc
       lower bound of E_mu0: .106
       upper bound of E_mu0: (1) 5000 GeV, (2) 1 TeV.
       2
       nthrows = 10000
       phi offset (degrees) = 14.48
       survival probability =0.502500
       muon energy (GeV) =61.508030
       muon intensity (cm^-2 s^-1) =5.307842e-05
       neutron flux (cm^-3 s^-1) =1.227365e-08
       weighted theta = 2.050304
       weighted phi = 5.412201

5.  The energy distribution is in fdist_dc.dat and the double differential
    angular distribution is in gdist_dc.dat.

   output files:
   1.  fdistx.dat -- energy distribution
   2.  gdistx.dat -- theta-phi distribution
   3.  tdistx.dat -- theta distribution
   4.  pdistx.dat -- phi distribution
   5.  cdistx.dat -- cos(theta) distribution
   6.  ddistx.dat -- cos(theta)-phi distribution
   7.  hdistx.dat -- energy-theta distribution
   8.  qdistx.dat -- energy-phi distribution

6.  Below is a typical summary of run for mugen_dc.f:

[atang@localhost mudc]$ ./mugen
 RANLUX LUXURY LEVEL SET BY RLUXGO : 3     P= 223
 RANLUX INITIALIZED BY RLUXGO FROM SEEDS           1           0           0
 number of overlapped lattice points:  1866
 rmin (cm):   9310.36843
 possible low muon energy threshold (GeV):   45.0959135
 Processing lattice sites ......
 Begin simulation ....................
 PROCESSED  200000 THROWS.
 PROCESSED  400000 THROWS.
 PROCESSED  600000 THROWS.
 PROCESSED  800000 THROWS.
 PROCESSED  1000000 THROWS.
 nph, ncz, iph, jcz:  100 100 40 40
 number of overlapped lattice sites:  1866
 zenth angle cut, ctmin-->deg:   0. --> 89
 omega:   5.54107
 energy range:   1. -->   1.
 nthrows:   1000000
 number of surving muons:  40837
 survival probability:    0.040837
 emaxsim (GeV):   3428.21646
 number of seconds used in processing the lattice:  59
 number of seconds used in simulating muons:  9710

*! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ !
*! MUSIC: MUon SImulation Code
*! by P. Antonioli, C. Ghetti, E.V. Korolkova, 
*! V.A. Kudryavtsev, G. Sartorelli
*!
*!
*! Modified by Vitaly Kudryavtsev, April, 1999
*! NORMCO used to sample pairs of correlated Gaussian random numbers
*! was substituted by CORSET, CORGEN. As a result random generator
*! RNDM (now obsolete) is not used anymore. RANMAR is used instead.
*! Currently two random generators RANLUX and RANMAR are used in MUSIC.
*! Do not forget to initialize them using RLUXGO and RMARIN (see CERNLIB
*! documentation)
*! All angles are expressed now in radians instead of degrees to allow
*! the simulation on Linux
*! Sea water parameters (density and cross-sections) are used instead
*! of those for pure water
*!
*! For any problems please contact:
*! 
*! v.kudryavtsev@sheffield.ac.uk
*! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ !
*!
*! MUSIC is a 3D muon propagation code:
*! it takes into account energy losses and deflections
*! due breemstrahlung, pair production, inelastic scattering
*! and ionisation.
*! It simulates also the angular and lateral deflections due to
*! multiple scattering
*! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ !
*
*  Alfred Tang 1/10/2007
*
*  This file assumes standard rock.  If MUSIC data files for a specific
*  rock type is needed, please contact Vitaly Kudryavtsev at the above
*  email address.  In the case of a specific rock type different from
*  standard rock, the parameters n_z, n_a, n_rho, n_lambda
*  below need to be modified to match the actual rock data.  The MUSIC
*  data files music-cross-section-sr.dat and music-eloss-sr.dat
*  need to be re-calculated by Vitaly and the data file names below need
*  to be modified accordingly.

      subroutine initialize_music
      implicit real*8 (a-h,o-z)

      REAL*8 n_a,n_z,n_rho,n_lambda

      integer*4 j0
      real*4 v2(100),cs1(100,71,4),cs2(100,71,4)
      real*4 emulo(81,6),emc(81)
      real*4 ema(61),va(30),anga(50),dang(50,30,61)

      COMMON/sig/v2,cs1,cs2,j0
      COMMON/coenlo/emulo,emc
      COMMON/ang/ema,va,anga,dang
      COMMON/rock2/n_a,n_z,n_rho,n_lambda

* Rock description (need to be modified for non-standard rock)
      n_z=11.0       !Z, 11.00 for standard rock, 6.6 for pure water
      n_a=22.0       !A, 22.00 for standard rock, 11.89 for pure water
      n_rho=2.65     !density, 2.65 for standard rock
      n_lambda=26.48 !rad. length, 26.48 for standard rock
      ro=n_rho

*       reading of the muon energy losses
*      PRINT *,'music: loading energy losses table...'
      OPEN(UNIT=4,file='music-eloss-sr.dat',
     *form='formatted',status='old')
      READ(4,99)emulo
   99 FORMAT(16(5E12.5/),E12.5/)
      CLOSE(4)

*       reading of the arrays with the normalized 
*	(and integrated) double differential
*       cross-section of muon inelastic scattering
*       log10(E_mu(GeV))= 0.0 - 6.0 with a step of 0.1 (ema(61))
*       log10(v)= -0.1 - -3.0 with a step of 0.1 (va(30))
*       log10(theta(rad))= 0.4 - -4.5 with a step of 0.1 (anga(50))
*       normalized double differential cross-section dang(50,30,61)
*       was calculated using the program sign_ang_arr.for with
*       the subroutine sign_ang.for
*      PRINT *,'music: loading inel. scatt. cross section...'
      OPEN(UNIT=3,file='music-double-diff-rock.dat',
     *  FORM='formatted',STATUS='old')
      READ(3,122)ema,va,anga,dang
  122 FORMAT(5e15.7)
      CLOSE(3)

C       J0 - THE MINIMAL VALUE OF RELATIVE ENERGY LOSSES (E/EMU);
C               STARTING FROM THIS VALUE ALL KINDS OF MUON ENERGY
C               LOSSES EXCEPT FOR IONISATION ARE TREATED AS THE
C               THE FLUCTUATED ONES, FOR EXAMPLE: J0=201 MEANS
C               THAT FROM V=E/EMU=10**(-10) UP TO V=1 THE LOSSES
C               ARE TREATED AS THE FLUCTUATED ONES.
      J0=61

      DO I=1,100
        V2(I)=0.0-0.05*(I-1)
      END DO

      DO IL=1,81
        EMC(IL)=-1.0+0.1*(IL-1)
      END DO

C       READING THE INTEGRAL CROSS-SECTION
*      PRINT *,'music: loading integral cross sections...'
      OPEN(UNIT=1,file='music-cross-sections-sr.dat',
     *  FORM='formatted',STATUS='old')
      READ(1,3)CS2
    3 FORMAT(4(71(20(5E14.6/)/)/)/)
      CLOSE(UNIT=1)


C       FILLING THE ARRAY OF INTEGRAL CROSS-SECTIONS FOR THE SIMULATION

      do i=1,4
        do k=1,71
          do j=1,j0
             if(cs2(j0,k,i).gt.0.) then
      cs1(j,k,i)=cs2(j,k,i)/cs2(j0,k,i)
             end if
          end do
        end do
      end do

      return
      end

***********************************************************************

      subroutine muon_transport
     *(x0,y0,z0,cx0,cy0,cz0,Emuin0,depth0,tmu0)
      implicit real*8 (a-h,o-z)
      REAL*8 n_a,n_z,n_rho,n_lambda
      COMMON/rock2/n_a,n_z,n_rho,n_lambda
      parameter (pi=3.141592654d0)
      emuin=emuin0

                                !input and output parameters:
        emu_f=0.                !final muon energy

        depth=depth0*n_rho      !depth along z-axis in g/cm^2, input
        path_max=1000000.*100.  !maximal path of muon, input
        emu=emuin               !initial muon energy, input

        theta=0.                !angle with respect to z-axis, input and output
        phi=0.                  !angle with respect to x-axis, input and output
        dr=0.                   !muon path in the rock, output
        x=0.                    !deviation along the axes x,y, perpendicular
        y=0.                    !to z-axis, x,y-axes should be defined,
                                !input and output
        z=0.                    !z-coordinate
        t=0.                    !Initial muon path in rock, input
                                !emu_f - final energy of muon

        emu_0=emu
        theta0=theta
        phi0=phi
 
        CALL music(emu,depth,emu_f,x,y,z,t,theta,phi,dr,path_max)

        gamma=(Emu_0+Emu_f)/2./0.105655
        beta=dsqrt(gamma*gamma-1.)/gamma
        vmu=beta*29.9792458
        tmu=dr/vmu/n_rho
        tmu0=tmu0+tmu
        
        thetac=dacos(cz0)
        IF(cx0.NE.0.) THEN
         phic=datan(cy0/cx0)
        IF(cx0.LT.0.) phic=pi+phic
        END IF
        IF(cx0.EQ.0.) THEN
        phic=pi/2.
        IF(cy0.LT.0.) phic=pi*3./2.
        END IF
        IF(phic.GT.pi*2.) phic=-pi*2.+phic
        IF(phic.LT.0.) phic=phic+pi*2.

        call coord_transform(x1,y1,z1,x,y,z,thetac,phic)
        x0=x1/n_rho+x0
        y0=y1/n_rho+y0
        z0=z1/n_rho+z0
        theta0=thetac
        phi0=phic
        call angle_transform(theta0,phi0,theta,phi)
        cz0=dcos(theta0)
        cx0=dsin(theta0)*dcos(phi0)
        cy0=dsin(theta0)*dsin(phi0)
        emuin0=emu_f                   !if emu_f is less than 0.106 the muon
                                       ! was stopped
        if(emuin0.le.0.106d0) emuin0=0.d0

        return
        end

*! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ !
*! MUSIC: MUon SImulation Code
*! by P. Antonioli, C. Ghetti, E.V. Korolkova, 
*! V.A. Kudryavtsev, G. Sartorelli
*!
*! For any problems please contact:
*! 
*! antonioli@bo.infn.it
*! v.kudryavtsev@sheffield.ac.uk
*! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ !

*! MUSIC is a 3D muon propagation code:
*! it takes into account energy losses and deflections
*! due breemstrahlung, pair production, inelastic scattering
*! and ionisation.
*! It simulates also the angular and lateral deflections due to
*! multiple scattering

*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      SUBROUTINE MUSIC(Emu,zf,Emu_f,x,y,z,t0,theta,phi,dr,t10)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

C       V2(100) - ARRAY OF LOG OF RELATIVE ENERGY TRANSFERS (E/EMU) FOR WHICH
C               THE MUON INTERACTION INTEGRAL CROSS-SECTIONS WERE CALCULATED:
C               FROM 0.0 TO -5.0 WITH THE STEP OF -0.05. THE INTEGRATION STARTS
C               FROM FROM V2=ALOG10(E/EMU)=0.0 AND ENDS AT V2(I).
C       CS1(100,71,4) - ARRAY OF NORMALIZED INTEGRAL CROSS-SECTIONS FOR V2(50),
C               LOG OF MUON ENERGY (61) (FROM 0.0 (1 GEV) TO 6.0 (1000 TEV)
C               WITH THE STEP OF 0.1) AND 4 PROCESSES TAKING INTO ACCOUNT
C               (BREEMSTRAHLUNG, PAIR PRODUCTION, INELASTIC SCATTERING
C               AND IONISATION)

	implicit real*8 (a-h,o-z)
      REAL*8 mmu,n_a,n_z,n_rho,n_lambda
      real*4 yfl
      INTEGER*4 err
      INTEGER*4 ms_flag,d_flag
      PARAMETER (mmu=0.105655d0)
      PARAMETER (ms_flag=1)   !to switch off mult.scatt. put ms_flag=0
      PARAMETER (d_flag=1)    !to switch off scatt. due to other processes
                              ! put d_flag=0

      real*4 v2(100),cs1(100,71,4),cs2(100,71,4)
      integer*4 j0
      real*4 emulo(81,6),emc(81)
      COMMON/sig/v2,cs1,cs2,j0
      COMMON/coenlo/emulo,emc
      COMMON/rock2/n_a,n_z,n_rho,n_lambda

*       ema(61) - array of log of muon energies (GeV), 0.0, 0.1,...6.0.
*       va(30) - array of log of relative energy transfers, 0.0,-0.1,...-3.0.
*       anga(50) - array of log of scattering angles (rad), 0.4,0.3,...-4.5.
*       dang(50,30,61) - integral probability for muon scattering at an angle
*       larger than anga(i) for fixed values of ema(k) and va(j).

      real*4 ema(61),va(30),anga(50),dang(50,30,61)
      COMMON/ang/ema,va,anga,dang

      em=emu
      t1=t0
      err=0

    9 em1=EM
      J=dlog10(em1)*10.+2
      IF(J.GE.71) J=71
      J1=J-1

C       IF THE MUON ENERGY BECOME LESS THAN 1 GEV THERE IS NO
C       SIMULATION OF FLUCTUATED ENERGY LOSSES

      IF(em1.LE.1.) GO TO 7

C       SIMULATION OF THE INTERACTION POINT

      call ranlux(yfl,1)

      FP=1./(CS2(J0,J,1)+CS2(J0,J,2)+CS2(J0,J,3)+CS2(J0,J,4))
      FP1=1./(CS2(J0,J1,1)+CS2(J0,J1,2)+CS2(J0,J1,3)+CS2(J0,J1,4))
      FP=(FP-FP1)/(EMC(J+10)-EMC(J1+10))*(DLOG10(EM1)-EMC(J1+10))+FP1
      T=-FP*ALOG(YFL)
      T3=T1+T
      z1=T*dcos(theta)

   15 IF(z+z1.LE.zf) GO TO 10

*       If the next interaction point is deeper than the level of observation
*       we will calculate the continuous energy losses and multiple scattering
*       up to the level of observation

      IF(t3.GT.t10) THEN
        em1=mmu
        dr=t10
        go to 16
      END IF
      t2=(zf-z)/dabs(dcos(theta))
      dz=t2*dcos(theta)

C       CALCULATION OF THE CONTINUOUS ENERGY LOSSES:
C       DUE TO IONISATION AND OTHER PROCESSES FOR V=E/EMU<10**(-3)

      CALL vdem(em1,B0,BS)
      emf=em1-(em1*BS+B0)*T2
      IF(emf.LE.mmu) emf=mmu
      emi=10.**((dlog10(emf)+dlog10(em1))/2.)
      CALL vdem(emi,b0,bs)
      CALL vem(em1,b0,bs,t2,em3)
      IF(em3.LE.mmu) THEN
        dr=t1-t0+em1/b0
        em1=mmu
        go to 16
      END IF
      theta2=0.
      phi2=0.
      deltax=0.
      deltay=0.
      deltar=0.
      dx1=0.
      dy1=0.
      dz1=dz

*       simulation of the multiple scattering
      IF(ms_flag.EQ.1) THEN
        CALL multiple
     *(t2,em1,em3,b0,bs,theta2,phi2,deltax,deltay,deltar,err)
cc      IF (err.ne.0) WRITE (*,3057) err,em1,em3
 3057   FORMAT(1x,'%MUSIC-W, multiple error status ',i1,2(1x,f10.5),
     &    ' (standard call)')
      ENDIF

*       transformation of the coordinates
      CALL coord_transform(dx1,dy1,dz1,deltax,deltay,dz,theta,phi)
*       transformation of the angles
      IF(theta2.GT.0.) THEN
        CALL angle_transform(theta,phi,theta2,phi2)
      END IF

      em1=EM3
      IF(em3.LE.mmu) go to 16
      NM=1
      T=T-T2+deltar
      z=z+dz1
      x=x+dx1
      y=y+dy1
      t1=t1+t2+deltar

      GO TO 11

   10 CONTINUE

*       Calculation of the continuous energy losses of muon up to the next
*       interaction point
      CALL vdem(em1,B0,BS)
      emf=em1-(em1*BS+B0)*T
      IF(emf.LE.mmu) emf=mmu
      emi=10.**((dlog10(emf)+dlog10(em1))/2.)
      CALL vdem(emi,B0,BS)
      CALL vem(em1,B0,BS,T,EM2)
      IF(em2.LE.mmu) THEN
        dr=t1-t0+em1/b0
        em1=mmu
        go to 16
      END IF
      theta2=0.
      phi2=0.
      deltax=0.
      deltay=0.
      deltar=0.
      dx1=0.
      dy1=0.
      dz1=z1

      IF(ms_flag.EQ.1) THEN
        CALL multiple           !multiple scattering between 2 interactions
     *(t,em1,em2,b0,bs,theta2,phi2,deltax,deltay,deltar,err)
 3058   FORMAT(1x,'%MUSIC-W, multiple error status ',i1,2(1x,f10.5),
     &    ' (between two int. call)')
      END IF

*       transformation of the muon deflection to the base reference frame
      CALL coord_transform(dx1,dy1,dz1,deltax,deltay,z1,theta,phi)

      em1=em2
      IF(em1.LE.mmu) go to 16
      T1=T3+deltar
      z=z+dz1
      x=x+dx1
      y=y+dy1

      IF(theta2.GT.0.) THEN
*       transformation of the deflection angles to the base reference frame
        CALL angle_transform(theta,phi,theta2,phi2)
      END IF

      if(z.gt.zf) go to 11
      IF(em1.LE.1.) GO TO 7

      call ranlux(yfl,1)
      J=dlog10(em1)*10.+2
      J2=dlog10(em1)*10.+0.5+1
      IF(J.GE.71) J=71
      IF(J2.GE.71) J2=71
      J1=J-1

C       SIMULATION OF THE TYPE OF MUON INTERACTION
      css=cs2(j0,j,1)+cs2(j0,j,2)+cs2(j0,j,3)+cs2(j0,j,4)
      css1=cs2(j0,j1,1)+cs2(j0,j1,2)+cs2(j0,j1,3)+cs2(j0,j1,4)
      css=(css-css1)/(EMC(J+10)-EMC(J1+10))*(DLOG10(EM1)-EMC(J1+10))+
     *     css1
      al1=((cs2(j0,j,1)-cs2(j0,j1,1))/(EMC(J+10)-EMC(J1+10))*
     *     (DLOG10(EM1)-EMC(J1+10))+cs2(j0,j1,1))/css
      al2=((cs2(j0,j,2)-cs2(j0,j1,2))/(EMC(J+10)-EMC(J1+10))*
     *     (DLOG10(EM1)-EMC(J1+10))+cs2(j0,j1,2))/css
      al3=((cs2(j0,j,3)-cs2(j0,j1,3))/(EMC(J+10)-EMC(J1+10))*
     *     (DLOG10(EM1)-EMC(J1+10))+cs2(j0,j1,3))/css
      IF(yfl.GT.AL1) GO TO 20
      ip=1
      GO TO 23
   20 IF(YFL.GT.AL1+AL2) GO TO 21
      IP=2
      GO TO 23
   21 IF(YFL.GT.AL1+AL2+AL3) GO TO 22
      IP=3
      GO TO 23
   22 IP=4
   23 CONTINUE

C       SIMULATION OF THE FRACTION OF MUON ENERGY TRANSFERED
C       TO THE SECONDARY PARTICLE
      call ranlux(yfl,1)
      CALL vcs(j2,yfl,ip,v1)

      em=em1
c       simulation of the deflection angle of muon
      theta1=0.
      phi1=0.
      IF(ip.LE.3.AND.ip.GE.1.AND.d_flag.EQ.1) THEN
        CALL mu_scatt(ip,em,v1,theta1,phi1)
      END IF

      Demf=V1*em1
      EM=EM-Demf
      em1=em
c       transformation of the deflection angles to the base reference frame
      IF(theta1.GT.0.) THEN
        CALL angle_transform(theta,phi,theta1,phi1)
      END IF

      IF(em1.LE.mmu) go to 16
      GO TO 9
    7 CONTINUE

C       IF THE MUON ENERGY IS LESS THAN 1 GEV ONLY THE IONISATION
C       LOSSES ARE CALCULATED
      CALL vdem(em1,b0,bs)
      z4=zf-z
      t4=z4/dabs(dcos(theta))
      emf=em1-(em1*bs+b0)*t4
      IF(emf.LE.mmu) emf=mmu
      emi=10.**((dlog10(emf)+dlog10(em1))/2.)
      CALL vdem(emi,b0,bs)
      CALL vem(em1,b0,bs,t4,em3)
      IF(em3.LE.mmu) THEN
         dr=t1-t0+em1/b0
         em1=mmu
         go to 16
      END IF
      theta2=0.
      phi2=0.
      deltax=0.
      deltay=0.
      deltar=0.
      dx1=0.
      dy1=0.
      dz1=z4

*       simulation of the multiple scattering up to the level of observation
      IF(ms_flag.EQ.1) THEN
        CALL multiple
     *(t4,em1,em3,b0,bs,theta2,phi2,deltax,deltay,deltar,err)
 3059   FORMAT(1x,'%MUSIC-W, multiple error status ',i1,2(1x,f10.5),
     &    ' (after int. call)')
      END IF

*       transformation of the coordinates
      CALL coord_transform(dx1,dy1,dz1,deltax,deltay,z4,theta,phi)

      em1=em3
      IF(em1.LE.mmu) GO TO 16
      nm=2
      z=z+dz1
      x=x+dx1
      y=y+dy1
      t1=t1+t4+deltar

*       transformation of the angles
      IF(theta2.GT.0.) THEN
        CALL angle_transform(theta,phi,theta2,phi2)
      END IF

   11 CONTINUE

      dr=t1-t0
      emu_f=em1

   16 CONTINUE

      IF(em1.LE.mmu) emu_f=mmu

      RETURN
      END


*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      SUBROUTINE vcs(j,yfl,ip,v1)
C       CALCULATION OF THE FRACTION OF MUON ENERGY TRANSFERRED
C       TO THE SECONDARY PARTICLE
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       implicit real*8 (a-h,o-z)
      real*4 v2(100),cs1(100,71,4),cs2(100,71,4)
      integer*4 j0
      COMMON/sig/v2,cs1,cs2,j0
      real*4 yfl
      i=1
    1 i=i+1
      if(yfl.gt.cs1(i,j,ip)) go to 1
      v3=(v2(i)-v2(i-1))/(cs1(i,j,ip)-cs1(i-1,j,ip))*
     *  (yfl-cs1(i-1,j,ip))+v2(i-1)
      v1=10.**v3
      RETURN
      END


*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      SUBROUTINE vdem(EM,B0,BS)
C       CALCULATION OF THE IONISATION LOSSES PER G/CM**2 AND
C       THE RELATIVE ENERGY LOSSES DUE TO OTHER PROCESSES FOR
C       V=E/EMU<10**(-3)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      implicit real*8 (a-h,o-z)
      real*4 f(81,6),em0(81)
      COMMON/coenlo/f,em0

C       EM0 - ARRAY OF MUON ENERGIES FOR WHICH THE RELATIVE ENERGY LOSSES
C               FOR V<10**(-3) HAVE BEEN ALREADY CALCULATED

C       F - ARRAY OF RELATIVE ENERGY LOSSES FOR V<10**(-3)
C       NOTE: IN THIS VARIANT OF PROGRAM THE ARRAY FOR RELATIVE
C       ENERGY LOSSES FOR V<10**(-3) IS USED

C       IF THE MUON ENERGY IS LESS THAN 1 GEV ONLY THE IONISATION
C       LOSSES ARE CALCULATED

C       CALCULATION OF THE RELATIVE ENERGY LOSSES DUE TO BREEMSTRAHLUNG,
C       PAIR PRODUCTION AND INELASTIC SCATTERING FOR V<10**(-3)

      e1=dlog10(em)
      i=1
    4 i=i+1
      if(i.gt.81) go to 6
      if(e1.gt.em0(i)) go to 4
    6 if(i.gt.81) i=81
      f1=(f(i,5)-f(i-1,5))/(em0(i)-em0(i-1))*(e1-em0(i-1))+f(i-1,5)
      bs=f1
      if(bs.le.0.) bs=0.
      if(e1.le.0.) bs=0.
      f2=(f(i,6)-f(i-1,6))/(em0(i)-em0(i-1))*(e1-em0(i-1))+f(i-1,6)
      b0=f2
      IF(e1.LT.0.0.AND.e1.GT.-0.1) b0=f(10,6)
      IF(E1.LE.-0.9) B0=F(2,6)
      if(b0.le.0.) b0=0.

      RETURN
      END

*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      SUBROUTINE vem(EM0,B0,BS,T,EM)
C       CALCULATION OF THE CONTINUOUS ENERGY LOSSES
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      implicit real*8 (a-h,o-z)
      IF(bs*t.LE.1.e-6) GO TO 1
      em=em0*dexp(-bs*t)-b0/bs*(1.-dexp(-bs*t))
      return
    1 em=em0-b0*t-bs*t*em0
      RETURN
      END

*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      SUBROUTINE defl(em,ip,v,theta,phi)
*       Simulation of the muon scattering angles due to
*       inelastic scattering
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      implicit real*8 (a-h,o-z)
      real*4 ema(61),va(30),anga(50),dang(50,30,61)
      COMMON/ang/ema,va,anga,dang
      REAL*8 ang(2,2)
      real*4 yfl
	parameter (pi=3.141592654d0)	
      IF(ip.EQ.3) THEN
        call ranlux(yfl,1)
        IF(em.LE.1.) RETURN
        eml=dlog10(em)
        k1=10.*eml+1.
        IF(k1.LT.1) k1=1
        IF(k1.GT.60) k1=60
        k2=k1+1
        IF(k2.LT.2) k2=2
        IF(k2.GT.61) k2=61
        vl=dlog10(v)
        m1=-vl*10.
        IF(m1.LT.1) m1=1
        IF(m1.GT.29) m1=29
        m2=m1+1
        IF(m2.LT.2) m2=2
        IF(m2.GT.30) m2=30
        DO kk=1,2
          IF(kk.EQ.1) k=k1
          IF(kk.EQ.2) k=k2
          DO mm=1,2
            IF(mm.EQ.1) m=m1
            IF(mm.EQ.2) m=m2
            j=1
    1       j=j+1
            IF(j.GT.49) THEN
              ang(mm,kk)=-5.
              go to 2
            END IF
            IF(yfl.GT.dang(j,m,k)) go to 1
            ang(mm,kk)=(anga(j)-anga(j-1))/(dang(j,m,k)-dang(j-1,m,k))*
     *        (yfl-dang(j-1,m,k))+anga(j-1)
    2       CONTINUE
          END DO
        END DO
        ang1=(ang(2,1)-ang(1,1))/(va(m2)-va(m1))*(vl-va(m1))+ang(1,1)
        ang2=(ang(2,2)-ang(1,2))/(va(m2)-va(m1))*(vl-va(m1))+ang(1,2)
        angt=(ang2-ang1)/(ema(k2)-ema(k1))*(eml-ema(k1))+ang1
cc        theta=10.**angt
        IF(angt.GT.-4.5) theta=10.**angt
        IF(angt.LE.-4.5) theta=0.
c        theta=180./pi*theta
	call ranlux(yfl,1)
        phi=2.*pi*yfl
        if(theta.eq.0.) phi=0.
      END IF
      RETURN
      END

*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      SUBROUTINE mu_scatt(jp,E,v,theta,phi)
      IMPLICIT NONE
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* Input:
      INTEGER*4 jp
!               * jp = 1 : bremsstrahlung
!               * jp = 2 : pair-production
!               * jp = 3 : nuclear
      REAL*8 E    !initial energy of the muon
      REAL*8 v        !fractional energy loss of muon
* Output:
      REAL*8 theta,phi
      REAL*4 yfl
* theta respect to parent muon direction,always positive!!!
* phi orthogonal to plane defined by parent muon direction
* theta phi in deg
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      REAL*8 mmu,pi,n_z,n_a,n_rho,n_lambda,mel,conv
      PARAMETER (pi=3.141592654)
      PARAMETER (conv=57.29577951)
      PARAMETER (mmu=105.655e-3)
      PARAMETER (mel=0.511e-3)

      real*4 ee,vv

      REAL*8 eoutmu,p2q
      COMMON/rock2/n_a,n_z,n_rho,n_lambda

* Bremsstrahlung declarations
      REAL*8 ak1,ak2,ak3,ak4,ak5,an,the1,the2,the3,the_mean,at


* Pair prod. declarations
      REAL*8 a_min

* Bremsstrahlung: following Van Ginneken

      IF (jp.EQ.1) THEN
        ak1=0.092*E**(-1./3.)
        ak3=0.22*E**(-0.92)
        ak4=0.26*E**(-0.91)
        an=0.81*dsqrt(E)/(dsqrt(E)+1.8)
        ak2=0.052/E*n_z**(-0.25)
        at=min(ak1*dsqrt(v),ak2)
        the1=max(at,ak3*v)
        the2=ak4*v**(1.+an)*(1.-v)**(-an)
        ak5=ak4*0.5**(1.+an)*0.5**(-an)/0.5**(-0.5)
        the3=ak5/dsqrt(1.-v)
        IF(v.LE.0.5) the_mean=the1
        IF(v.GT.0.5.AND.the2.LT.0.2) the_mean=the2
        IF(v.GT.0.5.AND.the2.GE.0.2) the_mean=the3
        the_mean=the_mean*the_mean
   10   call ranlux(yfl,1)
        theta=-the_mean*alog(yfl)
        theta=dsqrt(theta)
        IF(theta.GT.pi) go to 10
        call ranlux(yfl,1)
        phi=(2*pi)*(yfl)                   !uniform between 0 and 2*pi
c        theta=theta*(conv)              !from rad to deg
c        phi=(phi)*(conv)

      ELSE IF (jp.EQ.2) THEN
        ee=E
        vv=v
        a_min=min(8.9e-4*sqrt(sqrt(vv))*(1.+1.5e-5*ee)+0.032*vv/
     *    (vv+1.),0.1)
        the_mean=(2.3+dlog(E))/E/(1.-v)*(v-2.*mel/E)**2/v/v*a_min
        the_mean=the_mean*the_mean
   11   call ranlux(yfl,1)
        theta=-the_mean*alog(yfl)
        theta=dsqrt(theta)
        IF(theta.GT.pi) go to 11
        call ranlux(yfl,1)
        phi=(2*pi)*(yfl)                   !uniform between 0 and 2*pi
c        theta=theta*(conv)              !from rad to deg
c        phi=(phi)*(conv)

* Inelastic scattering

      ELSE IF (jp.EQ.3) THEN
        CALL defl(E,jp,v,theta,phi)

      ELSE
        PRINT *,'Invalid jp argument on mu_scat',jp
        STOP
      ENDIF
      RETURN
      END

*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      SUBROUTINE multiple
     *(x0,einmu,eoutmu,alpha,beta,theta,phi,deltax,deltay,deltar,err)
      IMPLICIT NONE
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* Multiple scattering: following
* P.Lipari and T. Stanev, Phys. Rev. D, 44, 3543 (1991) and
* L. Highland, Nucl. Instr. and Methods, 129, 497 (1975)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* Input:
      REAL*8 x0        !in km w.e.
      REAL*8 einmu     !initial energy of the muon
      REAL*8 eoutmu    !final energy of the muon
      REAL*8 alpha     !ionization energy loss of muon
      REAL*8 beta      !relative (continuous) energy losses of muon
                       !due to other processes
* Output:
      REAL*8 theta
      REAL*8 phi
      REAL*8 deltax,deltay
      REAL*8 deltar             !approximate increase of a muon path
      INTEGER*4 err             !error flag (err=1) indicates that
                                !einmu or eoutmu is less than mmu
                                !error flag (err=2) indicates that
                                !integral along path is LE.0

* theta respect to parent muon direction
* phi orthogonal to plane defined by parent muon direction
* theta phi in deg
* deltax,deltay    lateral displacement of the muon in g/cm^2
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* Multiple scattering declarations
      REAL*8 mmu,pi,mel,conv
      PARAMETER (pi=3.141592654)
      PARAMETER (conv=57.29577951)
      PARAMETER (mmu=105.655e-3)
      PARAMETER (mel=0.511e-3)


      REAL*8 ems,sigma,sigt,xx,yy,ro
      REAL*8 sigmat,sigmax,thetax,thetay,zz,sz,step,sz1
      REAL*8 p1,g1,bet1,p2,g2,bet2
      REAL*8 n_a,n_z,n_rho,n_lambda
      REAL*4 sigmatt,sigmaxx,roo,thetaxx,thetayy,xxx,yyy
      REAL*4 vv(2,2),cc(2,2),vcx(2)

C      PARAMETER (ems=0.0124)                 !in Gev (cfr Highland)
C      PARAMETER (ems=0.014)                  !in Gev (cfr Lipari)
      PARAMETER (ems=0.015)                  !in Gev (060697)

      COMMON/rock2/n_a,n_z,n_rho,n_lambda

      err=0
      IF(einmu.LE.mmu.OR.eoutmu.LE.mmu) THEN
        err=1
        RETURN
      END IF
      p1=dsqrt(einmu*einmu-mmu*mmu)
      g1=einmu/mmu
      bet1=dsqrt(g1*g1-1.)/g1
      p2=dsqrt(eoutmu*eoutmu-mmu*mmu)
      g2=eoutmu/mmu
      bet2=dsqrt(g2*g2-1.)/g2

      IF(beta.GT.0.) THEN
        sigt=1./alpha*(1./p2/bet2-1./p1/bet1)+beta/alpha/alpha*
     *    (dlog(dabs(1.+alpha/beta/p1/bet1))-
     *    dlog(dabs(1.+alpha/beta/p2/bet2)))
      END IF
      IF(beta.EQ.0.) THEN
        sigt=1./alpha*(1./p2/bet2-1./p1/bet1)
      END IF
      IF(sigt.LE.0.) THEN
        sigt=1./p1/bet1/p1/bet1
      END IF
      sigma=sigt*ems*ems/n_lambda
      sigmat=dsqrt(sigma)              !sigma(theta_x)=sigma(theta_y)
      IF(einmu.EQ.eoutmu) THEN                        !for test programs
        sigmat=dsqrt(ems*ems*x0/einmu/einmu/n_lambda)    !
      END IF						!
      sz=0.
      step=x0/100.
      zz=0.
    1 zz=zz+step/2.
      IF(beta.GT.0.) THEN
        sz1=p1*bet1*dexp(-beta*zz)-alpha/beta*(1.-dexp(-beta*zz))
      END IF
      IF(beta.EQ.0.) THEN
        sz1=p1*bet1-alpha*zz
      END IF
      IF(sz1.LE.mmu) THEN
        sz=0.
        go to 3
      END IF
      sz=sz+zz*zz*step/sz1/sz1
      zz=zz+step/2.
      IF(zz.LT.x0) go to 1
    3 CONTINUE
      IF(sz.LE.0.) THEN
        sz=x0*x0*x0/3./p1/bet1/p1/bet1
      END IF
      IF(sz.LE.0.) THEN
        err=2
        RETURN
      END IF
      sigmax=dsqrt(sz*ems*ems/n_lambda)        !sigma(x)=sigma(y)
      ro=sqrt(3.)/2.                  !correlation coefficient
    2 CONTINUE
      sigmatt=sigmat
      sigmaxx=sigmax
      roo=ro
c      CALL normco(thetaxx,xxx,0.,0.,sigmatt,sigmaxx,roo) !simulation of thetax,
c      CALL normco(thetayy,yyy,0.,0.,sigmatt,sigmaxx,roo) !thetay,xx,yy
	vv(1,1)=sigmatt*sigmatt
	vv(2,2)=sigmaxx*sigmaxx
	vv(1,2)=roo*sigmatt*sigmaxx
	vv(2,1)=roo*sigmatt*sigmaxx
	call corset(vv,cc,2)
	call corgen(cc,vcx,2)
	thetaxx=vcx(1)
	xxx=vcx(2)
	call corgen(cc,vcx,2)
	thetayy=vcx(1)
	yyy=vcx(2)
c      thetax=conv*thetaxx
c      thetay=conv*thetayy
      thetax=thetaxx
      thetay=thetayy
cc      IF(dabs(thetax).GE.pi/2..OR.dabs(thetay).GE.pi/2.) go to 2
      theta=datan(dsqrt(dtan(thetax)*dtan(thetax)+     !evaluation of theta
     *  dtan(thetay)*dtan(thetay)))                     !using thetax,thetay
      IF(dsin(thetax).NE.0.) THEN
        phi=datan(dtan(thetay)/dtan(thetax))            !evaluation of phi
        IF(dtan(thetax).LT.0.) phi=pi+phi             !using thetax,thetay
      END IF
      IF(dsin(thetax).EQ.0.) THEN
        phi=pi/2.
        IF(dtan(thetay).LT.0.) phi=pi*3./2.
      END IF
      IF(phi.GT.pi*2.) phi=-pi*2.+phi
      IF(phi.LT.0.) phi=phi+pi*2.
      deltax=xxx
      deltay=yyy
      deltar=sigmat*sigmat*x0

      RETURN
      END

*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	SUBROUTINE coord_transform(x,y,z,x1,y1,z1,theta1,phi1)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	IMPLICIT real*8 (a-h,o-z)
	parameter (pi=3.141592654d0)	
	phi2=phi1
	phi=phi2
	theta=theta1
	t11=dcos(theta)*dcos(phi)*dcos(phi)+dsin(phi)*dsin(phi)
	t21=dcos(theta)*dcos(phi)*dsin(phi)-dcos(phi)*dsin(phi)
	t31=-dsin(theta)*dcos(phi)
	t12=dcos(theta)*dcos(phi)*dsin(phi)-dcos(phi)*dsin(phi)
	t22=dcos(theta)*dsin(phi)*dsin(phi)+dcos(phi)*dcos(phi)
	t32=-dsin(theta)*dsin(phi)
	t13=dsin(theta)*dcos(phi)
	t23=dsin(theta)*dsin(phi)
	t33=dcos(theta)
	z=t31*x1+t32*y1+t33*z1
	x=t11*x1+t12*y1+t13*z1
	y=t21*x1+t22*y1+t23*z1
	RETURN
	END

*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	SUBROUTINE angle_transform(theta,phi,theta1,phi1)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	IMPLICIT real*8 (a-h,o-z)
	parameter (pi=3.141592654d0)
	if(theta.eq.0.d0) then
	theta=theta1
	phi=phi1
	return
	end if
	t11=dcos(theta)*dcos(phi)*dcos(phi)+dsin(phi)*dsin(phi)
	t21=dcos(theta)*dcos(phi)*dsin(phi)-dcos(phi)*dsin(phi)
	t31=-dsin(theta)*dcos(phi)
	t12=dcos(theta)*dcos(phi)*dsin(phi)-dcos(phi)*dsin(phi)
	t22=dcos(theta)*dsin(phi)*dsin(phi)+dcos(phi)*dcos(phi)
	t32=-dsin(theta)*dsin(phi)
	t13=dsin(theta)*dcos(phi)
	t23=dsin(theta)*dsin(phi)
	t33=dcos(theta)
	x2=dsin(theta1)*dcos(phi1)
	y2=dsin(theta1)*dsin(phi1)
	z2=dcos(theta1)
	z21=t31*x2+t32*y2+t33*z2
	x21=t11*x2+t12*y2+t13*z2
	y21=t21*x2+t22*y2+t23*z2
	if(z21.gt.1.d0) z21=1.d0
	if(z21.lt.-1.d0) z21=-1.d0
	theta=dacos(z21)
	IF(x21.NE.0.d0) THEN
	phi=datan(y21/x21)
	IF(x21.LT.0.d0) phi=pi+phi
	END IF
	IF(x21.EQ.0.d0) THEN
	phi=pi/2.
	IF(y21.LT.0.d0) phi=1.5*pi
	END IF
	IF(phi.GT.2.*pi) phi=-2.*pi+phi
	IF(phi.LT.0.d0) phi=phi+2.*pi
	RETURN
	END

      FUNCTION RANUM()
      Implicit None
c----------------------------------------------------------------------
c  This is the standardized random number generator for NUMONTE, 
c  which currently uses the CERNLIB routine "RANLUX".  It returns 
c  a random number in the interval (0.,1.), the end points excluded.
c
c  RANUM initializes itself depending on flags set by the user.
c  If NEWSEED=.FALSE. then the system default seeds are used
c  If true, seed values saved at the end of the last MC run are used, 
c  as read in by routine SEEDINIT (see "seedinit.F")
c----------------------------------------------------------------------

      REAL RAN,ranum,tinynum

      parameter (tinynum=1.e-19)

      LOGICAL FIRST,AOK
      DATA FIRST /.TRUE./
      if (FIRST) FIRST= .FALSE.

      CALL RANLUX(ran,1)
      RANUM= RAN

      if (RANUM.LT.tinynum) RANUM=tinynum

      AOK = .FALSE.
      IF ((RANUM.LE.1.1).AND.(RANUM.GE.TINYNUM)) AOK = .TRUE.
      IF (.NOT.(AOK)) CALL SEEDINIT(FIRST,314159)

      RETURN
      END


      SUBROUTINE SEEDINIT(FIRST,ISINI)

      IMPLICIT NONE

c----------------------------------------------
c     Initialize (or re-initialize) random 
c     number generator
c----------------------------------------------

      LOGICAL FIRST
      INTEGER ISINI,JSINI,KSINI

      IF (FIRST) THEN
         JSINI = 0
         KSINI = 0
      ELSE
         ISINI = 314159272
         JSINI = 0
         KSINI = 0
      ENDIF         

      CALL RLUXGO(2,ISINI,JSINI,KSINI) !..sets RANLUX seeds

      RETURN
      END

      PROGRAM MUGEN
*
*             Generate final muon momentum (px,py,pz) for a generic
*     underground detector
*
*
*     Contact:  Alfred Tang
*
*     Parameters:
*     ==========
*     nph            number of grid points along phi
*     ncz            number of grid points along cos(theta)
*     iph            number of search grid points along phi
*     jcz            number of search grid points along cos(theta)
*
*     Specification:-
*     =============
*     This code uses MUSIC to compute transport from a generic mountain
*     surface to an ungerground lab.  esimmax is the maximum muon energy
*     simulated.  As an example, the detector is assumed to an unright
*     cylinder.  The default value of lemin is set to the minimum which is
*     lemin=log(rest mass of muon).  lemin should be changed to correspond
*     to the minimum energy of the surviving muons crossing the minimum
*     thickness of rock.
*
*     Program Notes:-
*     =============
*     border.dat     input file containing the border of the hill profile
*     labxyz.dat     input file containing the lattice points of the hill
*                    profile
*     pxyz.dat       output file containing final muon momentum (px,py,pz)
*
*     The matrix elements ha(nph,ncz,i) with i=1,2 stores slant
*     depth in cm.
*
*     base = the offset corresponding to the center of the detector
*            above sealevel in meters (The top of the detector is
*            350m above sealevel.)
*     h0 = height of the tank in cm
*     r0 = radius of the tank in cm
*     pheh = azymuthal angle of the major axis of the hall in degrees
*     rest = muon rest mass
*     lemin = log10(E_min)  log of low muon energy cutoff
*     lemax = log10(E_max)  log of high muon energy cutoff
*     option = 1,2
*              (1) muons sampled at the center of the detector
*              (2) muons sampled on a large hemisphere
*     rhsp = radius of the hemispherical vacuum in cm

      implicit real*8 (a-h,o-z)
      integer option,ns
      double precision lemin,lemax,le
      parameter (pi=3.1415926535897932384626433)
      parameter (rho=2.65)
      parameter (base=0.)
      parameter (h0=678.)
      parameter (r0=326.5)
      parameter (rest=0.105658369)
      parameter (lemax=6.00000000)
      parameter (lemin=-0.97469413)
      parameter (rhsp=1000.)
      parameter (ns=500)
      parameter (option=2)

      integer ncz,nph,i,j,m,n,iph,jcz,il,iu,jl,ju,ih,istart,found,i1,i2
      integer p,m0,t1,t2,t3
      parameter (nph=100)
      parameter (ncz=100)
      parameter (iph=40)
      parameter (jcz=40)
      double precision ha(nph,ncz,3),ctm(nph,2)
      integer nb(nph,2)
      DOUBLE PRECISION CTMIN, CTMAX, k2
      double precision xe(ns),we(ns),xa(ns),wa(ns),norm
      PARAMETER (CTMAX = 1.0)  
      real*4 rcz,rp,rf,re,rh

      nthrows=10000

      call initialize_music
      iranlux=1
      iranlux1=1
      call rluxgo(3,iranlux,0,0)
      call rmarin(iranlux1,0,0)

      x0=0.
      y0=0.
      z0=0.
      ttime0=0.
      kmu=0
      emu=0.
      rmu=0.
      xmu=0.
      ymu=0.
      zmu=0.
      themu=0.
      phimu=0.
      theta=0.
      the=0.
      phi=0.
      ph=0.
      ih=0
      icount=0
      rmin=1.e20
      t1=0
      t2=0
      t3=0
      flevel=0.
      ftest=0.
      emax=0.
      px=0.
      py=0.
      pz=0.
      p0=0.
      k2=0.
      esim=0.
      esimmax=0.
      emin=10.**lemin
      emax=10.**lemax
      cthmax=1.
      fmax=cosmic_flux(emin,cthmax)
      fmin=cosmic_flux(emax,cthmax)
      fend=10.**lemax*fmin
      fdeno=10.**lemin*fmax-fend

      open(unit=10,file='border.dat',
     *form='formatted',status='old')
      open(unit=11,file='labxyz.dat',
     *form='formatted',status='old')
      open(unit=12,file='pxyz.dat',
     *form='formatted')
      open(unit=13,file='mugen.dat',
     *form='formatted')
      read(11,*) omega1,omega2,omega3,omega4
      omega=omega1+omega2+omega3+omega4
      read(11,*) ctmin

      t1=time()

      do 19 i=1,nph
         nb(i,1)=0
         nb(i,2)=0
         ctm(i,1)=0.
         ctm(i,2)=0.
 19   continue

 20   read(10,*,end=21)phi,cz
      i=int(phi/2./pi*nph)+1
      j=int((cz-ctmin)/(1.-ctmin)*ncz)+1
      nb(i,1)=nb(i,1)+j
      nb(i,2)=nb(i,2)+1
      ctm(i,1)=ctm(i,1)+cz
      ctm(i,2)=ctm(i,2)+1.
      goto 20
 21   close(10)

      found=0
      ilast=1
      do 22 i=1,nph
         if(nb(i,2).ne.0) then
            nb(i,1)=nb(i,1)/nb(i,2)
            ctm(i,1)=ctm(i,1)/ctm(i,2)
            ilast=i
         endif
      if(found.ne.1.and.nb(i,2).ne.0) then
         istart=i
         found=1
      endif
 22   continue

      i1=istart
      do 23 i=1,nph
         if(nb(i,2).ne.0) i1=i
         if(i.le.istart) then
            i1=ilast
            i0=ilast-nph
            i2=istart
            nb(i,1)=(i-i0)/(i2-i0)*(nb(i2,1)-nb(i1,1))+nb(i1,1)
            ctm(i,1)=(i-i0)/(i2-i0)*(ctm(i2,1)-ctm(i1,1))+ctm(i1,1)
         else
         if(nb(i,2).eq.0) then
            j=i
 24         j=j+1
            if(nb(j,2).eq.0.and.j.lt.nph) goto 24
            if(i.eq.nph) i2=i+istart
            if(i.lt.nph) i2=j
            nb(i,1)=(i-i1)/(i2-i1)*(nb(i2,1)-nb(i1,1))+nb(i1,1)
            ctm(i,1)=(i-i1)/(i2-i1)*(ctm(i2,1)-ctm(i1,1))+ctm(i1,1)
         endif
         endif
 23   continue

      do 3 i=1,nph
         do 4 j=1,ncz
            ha(i,j,1)=0.
            ha(i,j,2)=0.
            ha(i,j,3)=0.
 4       continue
 3    continue

 12   read (11,*,end=13) x0,y0,z0
      z0=z0-base
      if(z0.lt.0.) z0=0.
      r=dsqrt(x0**2+y0**2+z0**2)
      cx=x0/r
      cy=y0/r
      cz=z0/r
      IF(cx.NE.0.) THEN
         phi=datan(cy/cx)
         IF(cx.LT.0.) phi=pi+phi
      END IF
      IF(cx.EQ.0.) THEN
         phi=pi/2.
         IF(cy.LT.0.) phi=pi*3./2.
      END IF
      IF(phi.GT.pi*2.) phi=-pi*2.+phi
      IF(phi.LT.0.) phi=phi+pi*2.
      i=int(phi/2./pi*nph)+1
      j=int((cz-ctmin)/(1.-ctmin)*ncz)+1
      ha(i,j,1)=ha(i,j,1)+r
      ha(i,j,2)=ha(i,j,2)+r
      ha(i,j,3)=ha(i,j,3)+1.
      go to 12
 13   close(11)

      do 1 i=1,nph
         do 2 j=1,ncz
            if(ha(i,j,3).ne.0.) then
               ha(i,j,1)=ha(i,j,1)/ha(i,j,3)
               ha(i,j,2)=ha(i,j,2)/ha(i,j,3)
               if(ha(i,j,1).lt.rmin) rmin=ha(i,j,1)
            endif
            if(ha(i,j,3).gt.1.) ih=ih+1
 2       continue
 1    continue
      print*,'number of overlapped lattice points: ',ih
      print*,'rmin (cm): ',rmin
      print*,'suggested low muon energy threshold (GeV): ',
     $ 500.*(exp(.35*rmin/100000.*2.65)-1.)

      print*,'Processing lattice sites ......'

      do 5 i=1,nph
         do 6 j=1,ncz
            if(j.ge.nb(i,1)) then
            test=0.
            tempmax=0.
            il=i-iph
            ju=j+jcz
            do 7 m0=1,2*iph+1
               m=m0-1+il
               p=m
               if(m.lt.1) p=nph+m
               if(m.gt.nph) p=m-nph
               do 8 n=nb(p,1),ju
                  if(n.le.ncz) then
                  ph1=i*2.*pi/nph
                  th1=j*.5*pi/ncz
                  ph2=p*2.*pi/nph
                  th2=n*.5*pi/ncz
                  if(ha(p,n,3).gt.test) test=ha(p,n,3)
                   temp=dsin(th1)*dcos(ph1)*dsin(th2)*dcos(ph2)
     $                  +dsin(th1)*dsin(ph1)*dsin(th2)*dsin(ph2)
     $                  +dcos(th1)*dcos(th2)
                   if(temp.ge.tempmax.and.ha(p,n,3).ne.0.) then
                      tempmax=temp
                      ha(i,j,1)=ha(p,n,2)
                   endif
                   endif
 8             continue
 7          continue
            if(test.eq.0.) then
               print*,"error: grid too small"
               if(m.eq.0) print*,i,j,m0,n0,m,n,p
               stop
            endif
            endif
 6       continue
 5    continue

      t2=time()
      print*,'Begin simulation ....................'

      DO N = 1,NTHROWS
 66      call ranlux(rp,1)
         phi=rp*2.*pi
         i=int(phi/2./pi*nph)+1
         call ranlux(rcz,1)
         cz = ctm(i,1) + rcz*(CTMAX-ctm(i,1))
         j=int((cz-ctmin)/(1.-ctmin)*ncz)+1
         theta=dacos(cz)
         call ranlux(re,1)
         le=lemin+re*(lemax-lemin)
         emu=10.**le
         fthis=emu*cosmic_flux(emu,cz)
         ftest=(fthis-fend)/fdeno
         if(ftest.lt.0..or.ftest.gt.1.) goto 66
         call ranlux(rf,1)
         if(rf.gt.ftest) goto 66

         r=ha(i,j,1)

         if(option.eq.2) r=r-rhsp

* Resume muon transport
         cz0=cz
         cx0=dsin(theta)*dcos(phi)
         cy0=dsin(theta)*dsin(phi)
         x=r*cx0
         y=r*cy0
         z=r*cz0
         cx=-cx0
         cy=-cy0
         cz=-cz0
         ttime=ttime0
         depth=r
         call muon_transport(x,y,z,cx,cy,cz,emu,depth,ttime)
         IF(cx.NE.0.) THEN
            phi=datan(cy/cx)
            IF(cx.LT.0.) phi=pi+phi
         END IF
         IF(cx.EQ.0.) THEN
            phi=pi/2.
            IF(cy.LT.0.) phi=pi*3./2.
         END IF
         IF(phi.GT.pi*2.) phi=-pi*2.+phi
         IF(phi.LT.0.) phi=phi+pi*2.
         the = theta * 180. / pi
         ph = phi * 180. / pi

         if(emu.gt.0.) then
            kmu=kmu+1
            k2=emu**2-rest**2
            if(k2.lt.0.) then
               print*,'(Warning: negative k2!) emu = ',emu
            else
               p0=dsqrt(k2)
               px=p0*cx
               py=p0*cy
               pz=p0*cz
               esim=emu
               if(esim.gt.esimmax) esimmax=esim
               write(12,"(3E18.7)") px,py,pz
            endif
         end if

         icount=icount+1
         IF (MOD(icount,nthrows/5).EQ.0)
     $        WRITE(6,*) 'PROCESSED ',icount,' THROWS.'

      ENDDO

      if(kmu.gt.0) then
         spmu=1.*kmu/nthrows
      end if

      t3=time()

      print*,'nph, ncz, iph, jcz: ',nph,ncz,iph,jcz
      print*,'number of overlapped lattice sites: ',ih
      print*,'zenth angle cut, ctmin-->deg:  ',ctmin,' -->',
     $ int(dacos(ctmin)*180./pi)
      print*,'omega:                         ',omega
      print*,'nthrows:                        ',nthrows
      print*,'option:                         ',option
      print*,'number of surving muons:        ',kmu
      print*,'survival probability:          ',spmu
      print*,'emaxsim (GeV):                 ',esimmax
      print*,'number of seconds used in processing the lattice: ',t2-t1
      print*,'number of seconds used in simulating muons:       ',t3-t2

      write(13,*)'nph, ncz, iph, jcz: ',nph,ncz,iph,jcz
      write(13,*)'number of overlapped lattice sites: ',ih
      write(13,*)'zenth angle cut, ctmin-->deg:  ',ctmin,' -->',
     $ int(dacos(ctmin)*180./pi)
      write(13,*)'omega:                         ',omega
      write(13,*)'nthrows:                        ',nthrows
      write(13,*)'option:                         ',option
      write(13,*)'number of surving muons:        ',kmu
      write(13,*)'survival probability:          ',spmu
      write(13,*)'emaxsim (GeV):                 ',esimmax
      write(13,*)'number of seconds used in processing the lattice: ',
     $ t2-t1
      write(13,*)'number of seconds used in simulating muons:       ',
     $ t3-t2

      close(12)
      close(13)
      stop
      END

      DOUBLE PRECISION FUNCTION COSMIC_FLUX(EMU,COSTH)
 
      IMPLICIT NONE
      REAL CS_A, CS_GAMMA, CS_RC
      integer model

      DOUBLE PRECISION CTMIN, CTMAX,de,emu0,emu1,em,low
      PARAMETER (CTMIN = 0.0)
      PARAMETER (CTMAX = 1.0)
      parameter (low = 1.)
 
      DOUBLE PRECISION EMU,COSTH,costa,PAR(2)
      DATA PAR /115., 850./

      costa=costh
      if(costa.ne.1.) then
      costa=dsqrt((costa**2+1.052122e-2-.068287*costa**.958633+
     $     .0407253*costa**.817285)/.9829595)
      endif
      if(costa.ge.1.) costa=1.

      cs_a=1.
      cs_gamma=2.7
      cs_rc=0.
      model=0
      emu0=emu
      emu1=emu

      if(emu0.le.low/costa) then
         emu0=(3.*emu0+7.*low/costa)/10.
         emu1=emu0
      endif

      if(emu0.le.100./costa) then
         cs_rc=1.e-4
         de=2.06e-3*(950./costa-90.)
         emu0=emu1+de
         cs_a=1.1*(9.*dsqrt(costh+.001)/103.)**(4.5/costa/emu0)
      endif
  
C     This function returns DI/Dcos*DE for muons at the Earth's surface.
 
      COSMIC_FLUX = 0.
      IF ((COSTH.LE.CTMIN).OR.(COSTH.GT.CTMAX)) RETURN
 
      IF (MODEL.EQ.0) THEN

         COSMIC_FLUX = CS_A * 0.14 * 
     $        (EMU1)**(-CS_GAMMA) *
     $        (1./(1.+1.1*EMU0*COSTA/PAR(1)) +
     $        0.054/(1.+1.1*EMU0*COSTA/PAR(2)) + CS_RC)
         
      ELSEIF (MODEL.EQ.1) THEN

         COSMIC_FLUX = CS_A * 372. / (EMU*COSTH + 80.) *
     $        (5.*EMU + 10./COSTH)**(-CS_GAMMA) *
     $        ((EMU + 15.)/(EMU + 15./COSTH))

      ENDIF

      RETURN
      END

      PROGRAM MUON
*
*             Calculate cosmic ray flux and throw event for
*     a generic underground detector
*
*
*     Contact:  Alfred Tang (Kansas State University)
*               atang@phys.ksu.edu
*               1/10/2007
*
*     Parameters:
*     ==========
*     nph            number of grid points along phi
*     ncz            number of grid points along cos(theta)
*     iph            number of search grid points along phi
*     jcz            number of search grid points along cos(theta)
*
*     Specification:-
*     =============
*     This code uses MUSIC to compute transport from a generic mountain
*     surface whose toplogy is specified by the data files labxyz.dat and
*     border.dat to a generic underground lab centered at the origin.
*     As an example, an upright cylindrical detector is assumed.  For other
*     detector geometry, a section of the code needs to be modified.
*     The neutron rate output is left there for historical reason.
*     Do not take this neutron rate too seriously.
*
*     Program Notes:-
*     =============
*     border.dat     input file containing the border of the hill profile
*     labxyz.dat     input file containing the lattice points of the hill
*                    profile
*     edbs.dat       output file containing the average outputs
*     edist.dat      output file containing raw data for post-processing
*
*     The matrix elements ha(nph,ncz,i) with i=1,2 stores slant
*     depth in cm.
*
*     base = the offset corresponding to the center of the detector
*            above sealevel in meters
*     h0 = height of the tank in cm
*     r0 = radius of the tank in cm
*     hi = height of the inner region in cm
*     ri = radius of the inner region in cm
*     rm = log10(muon rest mass)
*     rho = rock density

      implicit real*8 (a-h,o-z)
      parameter (pi=3.1415926535897932384626433)
      parameter (rho=2.65)
      parameter (base=0.)
      parameter (rm=-0.97469413)
*     The parameters of an upright cylindrical detector
      parameter (h0=245.8)
      parameter (r0=115.)
      parameter (hi=230.)
      parameter (ri=100.)
      parameter (hhc=350.)
      parameter (rrc=350.)

      integer ncz,nph,i,j,m,n,iph,jcz,il,iu,jl,ju,ih,istart,found,i1,i2
      integer p,m0
      parameter (nph=100)
      parameter (ncz=100)
      parameter (iph=40)
      parameter (jcz=40)
      double precision ha(nph,ncz,3),ctm(nph,2)
      integer nb(nph,2)
      DOUBLE PRECISION CTMIN, CTMAX,lmin,lmax,fac
      common/le/lmin,lmax
      PARAMETER (CTMAX = 1.0)  
      real*4 rcz,rp,rq,rh,rr

      nthrows=10000

      call initialize_music
      iranlux=1
      iranlux1=1
      call rluxgo(3,iranlux,0,0)
      call rmarin(iranlux1,0,0)

      x0=0.
      y0=0.
      z0=0.
      ttime0=0.
      kmu=0
      eemu=0.
      rmu=0.
      xmu=0.
      ymu=0.
      zmu=0.
      themu=0.
      phimu=0.
      weight=0.
      total_wt=0.
      total_rate=0.
      total_rate2=0.
      theta=0.
      the=0.
      phi=0.
      ph=0.
      ih=0
      icount=0
      a=r0**2*pi+2.*pi*r0*h0
      dhi=(h0-hi)/2.
      rmin=1.e20

      open(unit=10,file='border.dat',
     *form='formatted',status='old')
      open(unit=11,file='labxyz.dat',
     *form='formatted',status='old')
      open(unit=12,file='edist.dat',
     *form='formatted')
      open(unit=13,file='edbs.dat',
     *form='formatted')
      read(11,*) omega1,omega2,omega3,omega4
      omega=omega1+omega2+omega3+omega4
      read(11,*) ctmin
      write(12,*) omega

      do 19 i=1,nph
         nb(i,1)=0
         nb(i,2)=0
         ctm(i,1)=0.
         ctm(i,2)=0.
 19   continue

 20   read(10,*,end=21)phi,cz
      i=int(phi/2./pi*nph)+1
      j=int((cz-ctmin)/(1.-ctmin)*ncz)+1
      nb(i,1)=nb(i,1)+j
      nb(i,2)=nb(i,2)+1
      ctm(i,1)=ctm(i,1)+cz
      ctm(i,2)=ctm(i,2)+1.
      goto 20
 21   close(10)

      found=0
      ilast=1
      do 22 i=1,nph
         if(nb(i,2).ne.0) then
            nb(i,1)=nb(i,1)/nb(i,2)
            ctm(i,1)=ctm(i,1)/ctm(i,2)
            ilast=i
         endif
      if(found.ne.1.and.nb(i,2).ne.0) then
         istart=i
         found=1
      endif
 22   continue

      i1=istart
      do 23 i=1,nph
         if(nb(i,2).ne.0) i1=i
         if(i.le.istart) then
            i1=ilast
            i0=ilast-nph
            i2=istart
            nb(i,1)=(i-i0)/(i2-i0)*(nb(i2,1)-nb(i1,1))+nb(i1,1)
            ctm(i,1)=(i-i0)/(i2-i0)*(ctm(i2,1)-ctm(i1,1))+ctm(i1,1)
         else
         if(nb(i,2).eq.0) then
            j=i
 24         j=j+1
            if(nb(j,2).eq.0.and.j.lt.nph) goto 24
            if(i.eq.nph) i2=i+istart
            if(i.lt.nph) i2=j
            nb(i,1)=(i-i1)/(i2-i1)*(nb(i2,1)-nb(i1,1))+nb(i1,1)
            ctm(i,1)=(i-i1)/(i2-i1)*(ctm(i2,1)-ctm(i1,1))+ctm(i1,1)
         endif
         endif
 23   continue

      do 3 i=1,nph
         do 4 j=1,ncz
            ha(i,j,1)=0.
            ha(i,j,2)=0.
            ha(i,j,3)=0.
 4       continue
 3    continue

 12   read (11,*,end=13) x0,y0,z0
      z0=z0-base
      if(z0.lt.0.) z0=0.
      r=dsqrt(x0**2+y0**2+z0**2)
      cx=x0/r
      cy=y0/r
      cz=z0/r
      IF(cx.NE.0.) THEN
         phi=datan(cy/cx)
         IF(cx.LT.0.) phi=pi+phi
      END IF
      IF(cx.EQ.0.) THEN
         phi=pi/2.
         IF(cy.LT.0.) phi=pi*3./2.
      END IF
      IF(phi.GT.pi*2.) phi=-pi*2.+phi
      IF(phi.LT.0.) phi=phi+pi*2.
      i=int(phi/2./pi*nph)+1
      j=int((cz-ctmin)/(1.-ctmin)*ncz)+1
      ha(i,j,1)=ha(i,j,1)+r
      ha(i,j,2)=ha(i,j,2)+r
      ha(i,j,3)=ha(i,j,3)+1.
      go to 12
 13   close(11)

      do 1 i=1,nph
         do 2 j=1,ncz
            if(ha(i,j,3).ne.0.) then
               ha(i,j,1)=ha(i,j,1)/ha(i,j,3)
               ha(i,j,2)=ha(i,j,2)/ha(i,j,3)
               if(ha(i,j,1).lt.rmin) rmin=ha(i,j,1)
            endif
            if(ha(i,j,3).gt.1.) ih=ih+1
 2       continue
 1    continue
      print*,'number of overlapped lattice points: ',ih
      print*,'rmin (cm): ',rmin
      print*,'suggested low muon energy threshold (GeV): ',
     $ 500.*(exp(.35*rmin/100000.*2.65)-1.)

      print*,'Processing lattice sites ......'

      do 5 i=1,nph
         do 6 j=1,ncz
            if(j.ge.nb(i,1)) then
            test=0.
            tempmax=0.
            il=i-iph
            ju=j+jcz
            do 7 m0=1,2*iph+1
               m=m0-1+il
               p=m
               if(m.lt.1) p=nph+m
               if(m.gt.nph) p=m-nph
               do 8 n=nb(p,1),ju
                  if(n.le.ncz) then
                  ph1=i*2.*pi/nph
                  th1=j*.5*pi/ncz
                  ph2=p*2.*pi/nph
                  th2=n*.5*pi/ncz
                  if(ha(p,n,3).gt.test) test=ha(p,n,3)
                   temp=dsin(th1)*dcos(ph1)*dsin(th2)*dcos(ph2)
     $                  +dsin(th1)*dsin(ph1)*dsin(th2)*dsin(ph2)
     $                  +dcos(th1)*dcos(th2)
                   if(temp.ge.tempmax.and.ha(p,n,3).ne.0.) then
                      tempmax=temp
                      ha(i,j,1)=ha(p,n,2)
                   endif
                   endif
 8             continue
 7          continue
            if(test.eq.0.) then
               print*,"error: grid too small"
               if(m.eq.0) print*,i,j,m0,n0,m,n,p
               stop
            endif
            endif
 6       continue
 5    continue
      print*,'Begin simulation ....................'

      DO N = 1,NTHROWS
      call ranlux(rp,1)
      PHI = rp*2.*pi
      i=int(phi/2./pi*nph)+1
      call ranlux(rcz,1)
      cz = ctm(i,1) + rcz*(CTMAX-ctm(i,1))
      j=int((cz-ctmin)/(1.-ctmin)*ncz)+1
      theta=dacos(cz)
* Begin: simulate the effective area of the upright cylindrical detector
      call ranlux(rq,1)
      q=rq*pi
      call ranlux(rh,1)
      h=rh*hi+dhi
      call ranlux(rr,1)
      r=rr*ri
      dh=h0-h
      del=(r0-r)/dtan(theta)
      if(del.lt.dh) then
         xi=pi-q-dasin(r*dsin(q)/r0)
         r0r=dsin(theta)*dcos(q-pi/2.)*dcos(pi/2.-xi)
     $       +dsin(theta)*dsin(q-pi/2.)*dsin(pi/2.-xi)
      else
         r0r=dcos(theta)
      endif
* End
       call muon_cosmic_flux_surface
     $        (emu0,cz,weight,flux)
       r=ha(i,j,1)
* Resume muon transport
       cz0=cz
       cx0=dsin(theta)*dcos(phi)
       cy0=dsin(theta)*dsin(phi)
       x=r*cx0
       y=r*cy0
       z=r*cz0
       cx=-cx0
       cy=-cy0
       cz=-cz0
       emu=emu0
       ttime=ttime0
       depth=r
       call muon_transport(x,y,z,cx,cy,cz,emu,depth,ttime)
       theta=dacos(cz)
       IF(cx.NE.0.) THEN
          phi=datan(cy/cx)
          IF(cx.LT.0.) phi=pi+phi
       END IF
       IF(cx.EQ.0.) THEN
          phi=pi/2.
          IF(cy.LT.0.) phi=pi*3./2.
       END IF
       IF(phi.GT.pi*2.) phi=-pi*2.+phi
       IF(phi.LT.0.) phi=phi+pi*2.
       the = theta * 180. / pi
       ph = phi * 180. / pi

       if(emu.gt.0.) then
          kmu=kmu+1
          write(12,*)emu,flux,theta,phi
          eemu=eemu+emu*weight
          total_wt=total_wt+weight
          total_rate=total_rate+r0r
          total_rate2=total_rate2+weight*r0r
          xmu=xmu+x
          ymu=ymu+y
          zmu=zmu+z
          themu=themu+the
          phimu=phimu+ph
          rmu=sqrt(x*x+y*y)+rmu
       end if

      icount=icount+1
      IF (MOD(icount,nthrows/5).EQ.0)
     $ WRITE(6,*) 'PROCESSED ',icount,' THROWS.'

      ENDDO

      if(kmu.gt.0) then
         spmu=1.*kmu/nthrows
         eemu=eemu/total_wt
         xmu=xmu/kmu
         ymu=ymu/kmu
         zmu=zmu/kmu
         themu=themu/kmu
         phimu=phimu/kmu
         rmu=rmu/kmu
      end if

      total_wt=total_wt/nthrows*omega
      fac=(lmax-lmin)/(lmax-rm)
      total_rate=total_rate*total_wt/nthrows*a*fac
      total_rate2=total_rate2/nthrows*omega*a*spmu*fac
      ave_neutron=total_wt*rho*4.14e-6*eemu**.74

      print*,'nph, ncz, iph, jcz: ',nph,ncz,iph,jcz
      print*,'number of overlapped lattice sites: ',ih
      print*,'zenth angle cut, ctmin-->deg: ',ctmin,' -->',
     $ int(dacos(ctmin)*180./pi)
      print*,'omega: ',omega
      print*,'energy range: ',10.**lmin,' --> ',10.**lmax
      print*,'nthrows:  ',nthrows
      print*,'fake survival probability:  ',spmu
      print*,'ave energy in GeV: ',eemu
      print*,'ave intensity in mu/cm-sq/s: ',total_wt
      print*,'muon rate (Hz)--method 1            :',total_rate
      print*,'muon rate (Hz)--method 2 (preferred): ',total_rate2
      print*,'x,y,z in cm',xmu,ymu,zmu
      print*,'lateral displacement in cm',rmu
      print*,'theta in degrees',themu
      print*,'phi in degrees',phimu
      print*,'fake neutron intensity in n/cm^3/s',ave_neutron

      write(13,*)'nph, ncz, iph, jcz: ',nph,ncz,iph,jcz
      write(13,*)'number of overlapped lattice sites: ',ih
      write(13,*)'zenth angle cut, ctmin-->deg: ',ctmin,' -->',
     $ int(dacos(ctmin)*180./pi)
      write(13,*)'omega: ',omega
      write(13,*)'energy range: ',10.**lmin,' --> ',10.**lmax
      write(13,*)'nthrows:  ',nthrows
      write(13,*)'fake survival probability:  ',spmu
      write(13,*)'ave energy in GeV: ',eemu
      write(13,*)'ave intensity in mu/cm-sq/s: ',total_wt
      write(13,*)'muon rate (Hz)--method 1            : ',total_rate
      write(13,*)'muon rate (Hz)--method 2 (preferred): ',total_rate2
      write(13,*)'x,y,z in cm',xmu,ymu,zmu
      write(13,*)'lateral displacement in cm',rmu
      write(13,*)'theta in degrees',themu
      write(13,*)'phi in degrees',phimu
      write(13,*)'fake neutron intensity in n/cm^3/s',ave_neutron

      close(12)
      close(13)
      stop

      END

      SUBROUTINE MUON_COSMIC_FLUX_SURFACE
     $     (EMUON,cz,WEIGHT,flux)
*
*     Calculate cosmic ray flux at the surface.
*
*
*     Contact:  Alfred Tang
*
*     Parameters:
*     ==========
*
*           emuon,theta,phi:           <out>
*                      muon energy (GeV) and direction
*           weight:                    <out>
*                      probability of event.
*
*     Specification:-
*     =============
*     This code uses modified Gaisser's muon flux at the surface to find energy
*     and angular distribution.
 
      IMPLICIT NONE
      LOGICAL FIRST
      integer model
      DOUBLE PRECISION EMUON,WEIGHT,costh
      DOUBLE PRECISION DIDE, EMU,flux,cz,lmin,lmax
      DOUBLE PRECISION I_TOT, DE, DCOSTH,iranlux
      DOUBLE PRECISION LEMU, JACOBIAN, COSMIC_FLUX
      real*4 re
      REAL RANUM
      DATA FIRST /.TRUE./
      SAVE FIRST
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO = 0.D0)
      EXTERNAL RANUM
      common/le/lmin,lmax
      DOUBLE PRECISION PI
      PARAMETER (PI = 3.1415926535897932384626433)

      DOUBLE PRECISION LEMAX, LEMIN
      PARAMETER (LEMIN  = -0.97469413)         ! log10 of 0.106 GeV
      PARAMETER (LEMAX  = 6.00000)             ! log10 of 1000 TeV
 
      real xs_cosmic_total

C     First, integrate muon flux to find normalization.
 
      I_TOT    = ZERO
      IF (FIRST) THEN
         FIRST = .FALSE.
         DE = (LEMAX-LEMIN)/1000.
         DCOSTH = 1./1000.
         DO LEMU = LEMIN, LEMAX, DE
            EMU = 10.**LEMU
            JACOBIAN = LOG(10.)*EMU
            DO COSTH = 0., 1., DCOSTH
               DIDE = COSMIC_FLUX(EMU,COSTH)
               I_TOT = I_TOT + JACOBIAN * DIDE * DE * DCOSTH
            ENDDO
         ENDDO
         XS_COSMIC_TOTAL = I_TOT*2.*pi
         WRITE(6,*) 'COSMIC FLUX = ',XS_COSMIC_TOTAL,'/cm-sq/s'
      ENDIF
 
C     For each event, throw the direction, energy, and associated weight
      lmin=lemin
      lmax=lemax

      call ranlux(re,1)
      lemu=lemin+re*(lemax-lemin)
      EMUON = 10.**(LEMU)
      JACOBIAN = LOG(10.)*EMUON

      costh=cz
      flux=COSMIC_FLUX(EMUON,COSTH)
      WEIGHT=(lemax-lemin)*JACOBIAN*flux
      flux=flux*emuon
 
      RETURN
      END
 
      DOUBLE PRECISION FUNCTION COSMIC_FLUX(EMU,COSTH)
 
      IMPLICIT NONE
      REAL CS_A, CS_GAMMA, CS_RC
      integer model

      DOUBLE PRECISION CTMIN, CTMAX,de,emu0,emu1,em,low
      PARAMETER (CTMIN = 0.0)
      PARAMETER (CTMAX = 1.0)
      parameter (low = 1.)
 
      DOUBLE PRECISION EMU,COSTH,costa,PAR(2)
      DATA PAR /115., 850./

      costa=costh
      if(costa.ne.1.) then
      costa=dsqrt((costa**2+1.052122e-2-.068287*costa**.958633+
     $     .0407253*costa**.817285)/.9829595)
      endif
      if(costa.ge.1.) costa=1.

      cs_a=1.
      cs_gamma=2.7
      cs_rc=0.
      model=0
      emu0=emu
      emu1=emu

      if(emu0.le.low/costa) then
         emu0=(3.*emu0+7.*low/costa)/10.
         emu1=emu0
      endif

      if(emu0.le.100./costa) then
         cs_rc=1.e-4
         de=2.06e-3*(950./costa-90.)
         emu0=emu1+de
         cs_a=1.1*(9.*dsqrt(costh+.001)/103.)**(4.5/costa/emu0)
      endif
  
C     This function returns DI/Dcos*DE for muons at the Earth's surface.
 
      COSMIC_FLUX = 0.
      IF ((COSTH.LE.CTMIN).OR.(COSTH.GT.CTMAX)) RETURN
 
      IF (MODEL.EQ.0) THEN

         COSMIC_FLUX = CS_A * 0.14 * 
     $        (EMU1)**(-CS_GAMMA) *
     $        (1./(1.+1.1*EMU0*COSTA/PAR(1)) +
     $        0.054/(1.+1.1*EMU0*COSTA/PAR(2)) + CS_RC)
         
      ELSEIF (MODEL.EQ.1) THEN

         COSMIC_FLUX = CS_A * 372. / (EMU*COSTH + 80.) *
     $        (5.*EMU + 10./COSTH)**(-CS_GAMMA) *
     $        ((EMU + 15.)/(EMU + 15./COSTH))

      ENDIF

      RETURN
      END
